﻿Type=Service
Version=3.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Private NOTIFICATION_ID As Int=1
	
	Public CurrentDisplays As Map
	Private DisplayManager1 As DisplayManager
	Private DisplayManagerDisplayListener1 As DisplayManagerDisplayListener
	Private Notification1 As Notification
End Sub

Sub Service_Create
	CurrentDisplays.Initialize
	
	DisplayManager1.Initialize
	DisplayManagerDisplayListener1=DisplayManager1.RegisterDisplayListener("DisplayManager1")
	
	Notification1.Initialize
	Notification1.Icon="icon"
	Notification1.Light=False
	Notification1.OnGoingEvent=True
	Notification1.SetInfo("DisplayService", "Monitoring external displays", Main)
	Notification1.Sound=False
	Notification1.Vibrate=False
	Notification1.Notify(NOTIFICATION_ID)
End Sub

Sub Service_Start (StartingIntent As Intent)
	CurrentDisplays.Clear
	Dim Displays() As Display=DisplayManager1.GetDisplays()
	For Each Display1 As Display In Displays
		CurrentDisplays.Put(Display1.GetDisplayId, Display1)
	Next
	CallSub(Main, "UpdateDisplaysListView")
End Sub

Sub Service_Destroy
	Notification1.Cancel(NOTIFICATION_ID)
	
	DisplayManager1.UnregisterDisplayListener(DisplayManagerDisplayListener1)
	'	free any references
	Dim CurrentDisplays As Map
	Dim DisplayManager1 As DisplayManager
	Dim DisplayManagerDisplayListener1 As DisplayManagerDisplayListener
End Sub

Sub DisplayManager1_DisplayAdded(DisplayId As Int)
	Log("DisplayManager1_DisplayAdded: "&DisplayId)
	ToastMessageShow("DisplayManager1_DisplayAdded: "&DisplayId, False)
	If Not(CurrentDisplays.ContainsKey(DisplayId)) Then
		CurrentDisplays.Put(DisplayId, DisplayManager1.GetDisplay(DisplayId))
		CallSub(Main, "UpdateDisplaysListView")
	End If
End Sub

Sub DisplayManager1_DisplayChanged(DisplayId As Int)
	Log("DisplayManager1_DisplayChanged: "&DisplayId)
	ToastMessageShow("DisplayManager1_DisplayChanged: "&DisplayId, False)
End Sub

Sub DisplayManager1_DisplayRemoved(DisplayId As Int)
	Log("DisplayManager1_DisplayRemoved: "&DisplayId)
	ToastMessageShow("DisplayManager1_DisplayRemoved: "&DisplayId, False)
	If CurrentDisplays.ContainsKey(DisplayId) Then
		CurrentDisplays.Remove(DisplayId)
		CallSub(Main, "UpdateDisplaysListView")
	Else
		Log("Removed Display was had not previously raised the DisplayAdded event")
	End If
End Sub
